//************************************ Compile Settings ************************************//
// Uncomment to use MySQL instead of the default nVault saving
//#define SQL

// Admin flag settings for giving points/badges and server saved data reset
// These can also be set in cmdaccess.ini without need to change here
// (See amxconst.inc for more admin level constants)
#define ADMIN_LEVEL ADMIN_IMMUNITY
#define ADMIN_RESET ADMIN_IMMUNITY

// Aby wlaczyc kolorowy say(colorchat) w grze odkomentuj
#define KOLOROWY_SAY

// Note: Changing any of the above the above requires plugin to be recompiled
//******************************************************************************************//
#include <amxmodx>
#include <amxmisc>
#include <fakemeta>
#include <fakemeta_util>
#include <hamsandwich>
#include <csx>

new const gPluginName[] = "JarHead Desert Rank Mod";
new const gPluginVersion[] = "1.0";

//Message sending variables
#if defined KOLOROWY_SAY
new gmsgStatusText;
new gmsgScreenFade;
new gmsgScreenShake;
#else
new gmsgStatusText;
new gmsgScreenFade;
new gmsgScreenShake;
new gmsgSayText;
#endif

new gHudSyncAimInfo;
new gMaxPlayers;
new bool:gCZBotRegisterHam;

#define MAX_RANKS 17
#define MAX_BADGES 8

//Motd variables
new configsdir[200];
new configfile[200];

//Cvar vars
new gPcvarJHDActive=1;
new gPcvarBadgesActive;
new gPcvarFreeAwp;
new gPcvarXpMultiplier;
new gPcvarIconTime;
new gPcvarFlagKills;
new gPcvarHelpUrl;
new gPcvarBadgePowers;
new gPcvarFlagRoundPoints;
new gPcvarFlagMatchPoints;
new gPcvarXpMinPlayers;
new gPcvarHudOptions;
new gPcvarStatusText;
new gPcvarFFA;
new gPcvarSaveType;
new gPcvarRankBots;
new gPcvarBotQuota;
new gPcvarSVLan;

//Cvar vars new
new gPcvarWymus;

//Current players info
new g_PlayerRank[33];
new g_PlayerBadges[33][MAX_BADGES];
new knifekills[33];
new pistolkills[33];
new sniperkills[33];
new parakills[33];
new defuses[33];
new plants[33];
new explosions[33];
new accuracy[33];
new totalkills[33];
new gSaveKey[33][32];
new smgkills[33];
new shotgunkills[33];
new riflekills[33];
new grenadekills[33];

new bronze[33];
new silver[33];
new gold[33];

//Temp storage variables
new numofbadges[33];
new bool:newplayer[33];
new g_lastwpn[33];
new bool:g_imobile[33];
new bool:freezetime;
new highestrank;
new highestrankid;
new gStatsLoaded[33];
new gCurrentFOV[33];

new g_friend[33];
new bool:g_invis[33];
new menuselection[33];

//Server stats
new highestrankserver, highestrankservername[32], mostkills, mostkillsid, mostkillsname[32], mostwins, mostwinsname[32];

new menuselected[33][3];
//0 - Badge/Kills selected 0/1
//1 - Badgenum/Kills
//2 - Badgelevel

//Sound Vars
new gSoundRank[] = "jhdrank/promotion.wav"; //Rank gained sound
new gSoundBadge[] = "jhdrank/award.wav"; //Badges earned sound

//Sprite vars
new gSprite[22];

#if defined SQL
	//SQl vars
	#include <sqlx>
	new Handle:g_SqlTuple;
	new g_Cache[512];
	new bool:SQLenabled;
	new bool:gIntermission;
#else
	//nVault
	#include <nvault>
	new g_Vault;
	new gPcvarPruneDays;
#endif

new gPlayerName;

//Jhd includes
#if defined KOLOROWY_SAY
#include <colorchat>
#endif
#include "jhd/stocks.inl"
#include "jhd/const.inl"
#include "jhd/effect.inl"
#include "jhd/cmds.inl"
#include "jhd/events.inl"
#include "jhd/save.inl"
#include "jhd/forwards.inl"
#include "jhd/check.inl"
#include "jhd/badgepowers.inl"
#include "jhd/menu.inl"
#include "jhd/hud.inl"
#include "jhd/othermods.inl"
#include "jhd/csx.inl"
#include "jhd/ham.inl"
#if defined SQL
#include "jhd/sql.inl"
#endif

public plugin_init()
{
	register_plugin(gPluginName, gPluginVersion, "MisieQ"); //Bazuje na Battlefield 2: Rank Mod 1.5.3 by pRED*

	//Register all the say commands

	//Public
	register_clcmd("say", "cmd_say", 0, "<target> ");
	register_clcmd("say_team", "cmd_say", 0, "<target> ");

	register_clcmd("say /mestats", "show_stats", 0, "Pokazuje twoje aktualne statystyki");
	register_clcmd("say_team /mestats", "show_stats", 0, "Pokazuje twoje aktualne statystyki");

	register_clcmd("say /serverstats", "show_server_stats", 0, "Pokazuje aktualne statystyki serwera");
	register_clcmd("say_team /serverstats", "show_server_stats", 0, "Pokazuje aktualne statystyki serwera");

	//Cvars

	//FCVAR_SERVER cvar for game monitor.
	register_cvar("jhd_version", gPluginVersion, FCVAR_SERVER);

	// Set cvar to update version in case new version loaded while server still running
	set_cvar_string("jhd_version", gPluginVersion);

	gPcvarJHDActive = register_cvar("jhd_active", "1");
	gPcvarHudOptions = register_cvar("jhd_hud_options", "abcde");
#if !defined SQL
	gPcvarPruneDays = register_cvar("jhd_reset_days", "21");
#endif
	gPcvarFFA = register_cvar("jhd_ffa", "0");
	gPcvarWymus = register_cvar("jhd_wymus", "0");
	gPcvarFlagKills = register_cvar("jhd_flag_kills", "2");
	gPcvarFlagRoundPoints = register_cvar("jhd_flag_round_kills", "0");
	gPcvarFlagMatchPoints = register_cvar("jhd_flag_match_kills", "0");

	gPcvarSaveType = get_cvar_pointer("csstats_rank");
	gPcvarRankBots = get_cvar_pointer("csstats_rankbots");
	gPcvarBotQuota = get_cvar_pointer("bot_quota");
	gPcvarSVLan = get_cvar_pointer("sv_lan");

	//Message sending.
	#if defined KOLOROWY_SAY
	gmsgStatusText = get_user_msgid("StatusText");
	gmsgScreenFade = get_user_msgid("ScreenFade");
	gmsgScreenShake = get_user_msgid("ScreenShake");
	#else
	gmsgStatusText = get_user_msgid("StatusText");
	gmsgScreenFade = get_user_msgid("ScreenFade");
	gmsgScreenShake = get_user_msgid("ScreenShake");
	gmsgSayText = get_user_msgid("SayText");
	#endif

	//Register events, logs and forwards to be captured
	register_event("HLTV", "Event_HLTV", "a", "1=0", "2=0"); //add freeztime start code
	register_event("CurWeapon", "Event_CurWeapon", "be", "1=1");
	register_event("SetFOV", "Event_SetFOV", "be");
	register_event("DeathMsg", "Event_DeathMsg", "a");

	register_logevent("LogEvent_Round_Start", 2, "0=World triggered", "1=Round_Start"); //freezetime end code
	register_logevent("LogEvent_Round_End", 2, "1=Round_End");

	register_message(SVC_INTERMISSION, "Message_Intermission");
	register_message(get_user_msgid("StatusValue"), "Message_StatusValue");

	register_event("StatusValue", "setTeam", "be", "1=1");
	register_event("StatusValue", "on_ShowStatus", "be", "1=2", "2!0");
	register_event("StatusValue", "on_HideStatus", "be", "1=1", "2=0");

	// Must use post or else is_user_alive will return false when dead player respawns
	RegisterHam(Ham_Spawn, "player", "Ham_Spawn_Post", 1);	// cz bots won't hook here must RegisterHamFromEntity
	RegisterHam(Ham_TakeDamage, "player", "Ham_TakeDamage_Pre");

	gHudSyncAimInfo = CreateHudSyncObj();
	gMaxPlayers = get_maxplayers();
	gPlayerName = get_xvar_id("PlayerName");
	
	register_forward(FM_PlayerPreThink, "Bug_Ciche_Chodzenie")
	
	#if defined SQL
	/* SQL */
	register_cvar("jhdrank_db_host", "localhost");
	register_cvar("jhdrank_db_user", "root");
	register_cvar("jhdrank_db_pass", "root");
	register_cvar("jhdrank_db_database", "jhdrank");
	#endif
}

public Bug_Ciche_Chodzenie(id) 
{
        if(is_user_alive(id)) 
        {
                new Float:fVector[3];
                pev(id, pev_velocity, fVector)
                new Float: fSpeed = floatsqroot(fVector[0]*fVector[0]+fVector[1]*fVector[1]+fVector[2]*fVector[2])
                if((fm_get_user_maxspeed(id) * 5) > (fSpeed*9))
                        set_pev(id, pev_flTimeStepSound, 300)
        }
}

